Sub Main

	Dim rcount As Integer
	Dim ccount As Integer
	Dim ucount As Integer
	Dim lcount As Integer
	Dim jcount As Integer
	Dim dcount As Integer
	Dim this_name As String
	Dim num_sheets As Integer
	
	num_sheets = ActiveDocument.Sheets.Count

	For aSheet = 1 To num_sheets
	
		ActiveDocument.Sheets(aSheet).Activate
		Set comps = ActiveDocument.ActiveSheet.Components
		
		Debug.Print "sheet #" & aSheet & ", components found: " & comps.Count
		
		For i = 1 To comps.Count Step 1
			this_name = comps.Item(i).Name
			Debug.Print "original name: " & this_name & " -> ";
			
			new_ref_num = Trim(Str(Val(Mid(this_name,2,4))+9000))
			new_name = Mid(this_name,1,1) & new_ref_num
			pre = UCase(Mid(this_name,1,1))
			
			'don't rename some components such as mounting holes, vias, etc...
			If pre = "R" Or pre = "C" Or pre = "L" Or pre = "U" Or pre = "D" Or pre = "J" Then
				If Val(Mid(this_name,2,5)) < 9000 Then
					Let comps.Item(i).Name = new_name
					Debug.Print "new name:" & new_name
				Else
					Debug.Print "already renamed"
				End If
			Else
				Debug.Print "skipped"
			End If
				
		Next i
		
	Next aSheet
	
	For aSheet = 1 To num_sheets
	
		ActiveDocument.Sheets(aSheet).Activate
		Set comps = ActiveDocument.ActiveSheet.Components
	
		For i = 1 To comps.Count Step 1
		
			this_name = comps.Item(i).Name
		
			Select Case UCase((Mid(this_name,1,1)))
				Case "R"
					rcount = rcount +1
					new_name = Mid(this_name,1,1) & rcount
					Let comps.Item(i).Name = new_name
				Case "C" 
					ccount = ccount + 1
					new_name = Mid(this_name,1,1) & ccount
					Let comps.Item(i).Name = new_name
				Case "U"
					ucount = ucount + 1
					new_name = Mid(this_name,1,1) & ucount
					Let comps.Item(i).Name = new_name
				Case "L"
					lcount = lcount + 1
					new_name = Mid(this_name,1,1) & lcount
					Let comps.Item(i).Name = new_name
				Case "D"
					dcount = dcount + 1
					new_name = Mid(this_name,1,1) & dcount
					Let comps.Item(i).Name = new_name
				Case "J"
					jcount = jcount + 1
					new_name = Mid(this_name,1,1) & jcount
					Let comps.Item(i).Name = new_name
				End Select
				
		Next i
	
	Next aSheet
	
	ActiveDocument.ActiveView.Refresh

End Sub

